package ru.ulstu.tsMethods.exponential;

import com.google.common.collect.ImmutableMap;
import ru.ulstu.models.exceptions.ModelingException;

import java.util.Map;

public class ExponentialMethodParams {
    Map<ExponentialParamName, Double> paramsValues;

    public ExponentialMethodParams(Map<ExponentialParamName, Double> paramsValues) {
        this.paramsValues = paramsValues;
    }

    public Double getValue(ExponentialParamName paramName) throws ModelingException {
        if (paramsValues.containsKey(paramName)) {
            return paramsValues.get(paramName);
        } else {
            throw new ModelingException("Неизвестное название параметра для метода экспоненциального сглаживания");
        }
    }

    public static ExponentialMethodParams of(ExponentialParamName param1, Double value1) {
        return new ExponentialMethodParams(ImmutableMap.of(param1, value1));
    }

    public static ExponentialMethodParams of(ExponentialParamName param1, Double value1, ExponentialParamName param2, Double value2) {
        return new ExponentialMethodParams(ImmutableMap.of(param1, value1, param2, value2));
    }
}
